
// The sys file should come first
#include "sys/axon.h"

#include "sensors/distance/sharp/GP2.h"
#include "sensors/distance/ping/PingSonar.h"
#include "actuators.h"
#include "servos.h"


#include "a2d.h"
#include "uart.h"
#include "rprintf.h"
#include "pwm.h"


// Define two servos

	SERVO left = MAKE_SERVO(FALSE, E3,1500, 500);
	SERVO right = MAKE_SERVO(FALSE , E4,1500, 500);
	SERVO top = MAKE_SERVO(FALSE, E2,1500, 500);
	SERVO bottom = MAKE_SERVO(FALSE , E1,1500, 500);

	// Create the list - remember to place an & at the
	// start of each servo name
	SERVO_LIST servos[] = {&left,&right, &top, &bottom};

	// Create a driver for the list of servos
	SERVO_DRIVER bank1 = MAKE_SERVO_DRIVER(servos);
	Sharp_GP2D12 IR1 = MAKE_Sharp_GP2D12(ADC0);			// ** FIXME - F0 and ADC0
	PingSonar PINGsensor = MAKE_PingSonar(F0);			// ** are the same thing - ie same pin


void  away_from_wall(void)
{//move away from wall
	act_setSpeed(&left, DRIVE_SPEED_MAX);
	act_setSpeed(&right, DRIVE_SPEED_MAX);
	act_setSpeed(&top, DRIVE_SPEED_MAX);
	act_setSpeed(&bottom, DRIVE_SPEED_MAX);

}
void towards_wall(void)
{//move towards the wall
	act_setSpeed(&left, DRIVE_SPEED_MAX);
	act_setSpeed(&right, DRIVE_SPEED_MAX);
	act_setSpeed(&top, DRIVE_SPEED_MIN);
	act_setSpeed(&bottom, DRIVE_SPEED_MIN);
}
void forward(void)
{
	act_setSpeed(&left, DRIVE_SPEED_MAX);
	act_setSpeed(&right, DRIVE_SPEED_MIN);

}
void rotate(void)
{
	act_setSpeed(&left, DRIVE_SPEED_MAX);
	act_setSpeed(&right, DRIVE_SPEED_MAX);
	act_setSpeed(&top, DRIVE_SPEED_MAX);
	act_setSpeed(&bottom, DRIVE_SPEED_MAX);
}

void appInitHardware(void){
	distanceInit(IR1);
	distanceInit(PINGsensor);
	

}
// This routine is called once to allow you to set up any other variables in your

// You can use 'clock' function here.
// The loopStart parameter has the current clock value in ?S
TICK_COUNT appInitSoftware(TICK_COUNT loopStart){
	return 0; // dont pause after
}

TICK_COUNT appControl(LOOP_COUNT loopCount, TICK_COUNT loopStart){
	distanceRead(IR1);
	distanceRead(PINGsensor);

	if (IR1.distance.cm > 4) 
	{
		do
		{ 
			distanceRead(IR1);
			away_from_wall();
		} while (IR1.distance.cm > 4 && PINGsensor.distance.cm < 4);
	}

	if (IR1.distance.cm < 4) 
	{
		do
		{ 
			distanceRead(IR1);
			towards_wall();
		} while (IR1.distance.cm < 4 && PINGsensor.distance.cm < 4);
	}

	if (IR1.distance.cm == 4) 
	{
		do
		{ 
			distanceRead(IR1);
			forward();
		} while (IR1.distance.cm == 4 && PINGsensor.distance.cm < 4);
	}

	if (PINGsensor.distance.cm < 4)
	{
		do
		{ 
			distanceRead(PINGsensor);
			rotate();
		} while (PINGsensor.distance.cm < 100);
	}
	
	return (10); // wait for 10 microseconds

}
